/** @file dsapu.h
 *  @author Mic
 *  @date 2006
 */

#ifndef __DSAPU_H__
#define __DSAPU_H__


#define APU_FREQ 32000
#define APU_CHN  2

#define HIGH 32767
#define LOW  -32767


/**
 * Sound format enum
 */
typedef enum soundFormat_t {
	FMT_PCM8,  
	FMT_PCM16, 
	FMT_ADPCM, 
	FMT_PSG   
};


typedef struct {
	int hz, len;
	bool stereo;
	short *buf;
	int pos[2],offset,datapos,cnt;
} tag_pcm;


/**
 *  @brief Sound channel struct
 */
typedef struct {
	soundFormat_t fmt;		/**< Format */
	unsigned int duty,		/**< Wave duty */
				 sad,		/**< Source address */
		         pos,		/**< Sample position */
				 end,		/**< Endpoint */
				 freq,		/**< Frequency */
				 delta,
				 delta2,
				 delta3,
				 looptype,
				 looppoint,
				 nwords,
				 nsamples;
	unsigned int left,
		         right;
	unsigned int timestamp;
	short vol,
		  adpcmSmp,
		  adpcmStartSmp;
	short noise;
	char adpcmIndex,
		 adpcmStartIndex;
	unsigned short tap;
	bool enabled;
} tag_sndchan;


void apu_mix();


#endif
