#include "colorfx.h"


void flip_colors(unsigned char *dst,unsigned char *src,int len)
{
	if (glFormat==GL_UNSIGNED_SHORT_5_5_5_1)
	{
		if (hasSSE2)
			__asm
			{
				pusha
				mov			esi,[src]
				mov			edi,[dst]
				mov			ecx,[len]
				movdqa		xmm0,[MASKBLUE]
				movdqa		xmm1,[MASKGREEN]
				shr			ecx,4
	__bgr0555_to_rgb5551_sse2:
				movdqu		xmm2,[esi]		// Read 8 colors
				movdqa		xmm3,xmm2		// Copy
				movdqa		xmm4,xmm2		// Copy
				pand		xmm2,xmm0
				psrlw		xmm3,10
				pand		xmm4,xmm1
				psllw		xmm2,11
				pand		xmm3,xmm0
				psllw		xmm4,1
				psllw		xmm3,1
				por			xmm2,xmm4
				add			esi,16
				por			xmm3,xmm2
				movdqu		[edi],xmm3
				add			edi,16
				dec			ecx
				jnz			__bgr0555_to_rgb5551_sse2
				popa
			}
		else
			__asm
			{
				pusha
				mov			esi,[src]
				mov			edi,[dst]
				mov			ecx,[len]
				movq		mm0,[MASKBLUE]
				movq		mm1,[MASKGREEN]
				shr			ecx,3
	__bgr0555_to_rgb5551_mmx:
				movq		mm2,[esi]	// Read 4 colors
				movq		mm3,mm2		// Copy
				movq		mm4,mm2		// Copy
				pand		mm2,mm0
				psrlw		mm3,10
				pand		mm4,mm1
				psllw		mm2,11
				pand		mm3,mm0
				psllw		mm4,1
				psllw		mm3,1
				por			mm2,mm4
				add			esi,8
				por			mm3,mm2
				movq		[edi],mm3
				add			edi,8
				dec			ecx
				jnz			__bgr0555_to_rgb5551_mmx
				popa
			}
	} else if (glFormat==GL_UNSIGNED_SHORT_5_6_5)
	{
	}
}


void flip_colors_5551_to_1555(unsigned char *dst,unsigned char *src,int len)
{
	__asm
	{
		pusha
		mov			esi,[src]
		mov			edi,[dst]
		mov			ecx,[len]
		movq		mm0,[MASKBLUE]
		movq		mm1,[MASKGREEN]
		shr			ecx,3
__rgb5551_to_bgr1555_mmx:
		movq		mm2,[esi]		// Read 4 colors
		movq		mm3,mm2			// Copy
		movq		mm4,mm2			// Copy
		psrlw mm2,1
		pand		mm2,mm0
		psrlw		mm3,11
		psllw		mm2,10
		pand		mm3,mm0
		psrlw		mm4,1
		pand		mm4,mm1
		por			mm2,mm4
		add			esi,8
		por			mm3,mm2
		movq		[edi],mm3
		add			edi,8
		dec			ecx
		jnz			__rgb5551_to_bgr1555_mmx
		popa
	}
}


void flip_colors_x555(unsigned char *dst,unsigned char *src,int len)
{
	if (hasSSE2)
		__asm
		{
			pusha
			mov			esi,[src]
			mov			edi,[dst]
			mov			ecx,[len]
			movdqa		xmm0,[MASKBLUE]
			movdqa		xmm1,[MASKGREEN]
			shr			ecx,4
__bgr0555_to_rgb5551_sse2:
			movdqu		xmm2,[esi]		// Read 8 colors
			movdqa		xmm3,xmm2		// Copy
			movdqa		xmm4,xmm2		// Copy
			pand		xmm2,xmm0
			psrlw		xmm3,10
			pand		xmm4,xmm1
			psllw		xmm2,10
			pand		xmm3,xmm0
			por			xmm2,xmm4
			add			esi,16
			por			xmm3,xmm2
			movdqu		[edi],xmm3
			add			edi,16
			dec			ecx
			jnz			__bgr0555_to_rgb5551_sse2
			popa
		}
	else
		__asm
		{
			pusha
			mov			esi,[src]
			mov			edi,[dst]
			mov			ecx,[len]
			movq		mm0,[MASKBLUE]
			movq		mm1,[MASKGREEN]
			shr			ecx,3
__bgr0555_to_rgb5551_mmx:
			movq		mm2,[esi]	// Read 4 colors
			movq		mm3,mm2		// Copy
			movq		mm4,mm2		// Copy
			pand		mm2,mm0
			psrlw		mm3,10
			pand		mm4,mm1
			psllw		mm2,10
			pand		mm3,mm0
			por			mm2,mm4
			add			esi,8
			por			mm3,mm2
			movq		[edi],mm3
			add			edi,8
			dec			ecx
			jnz			__bgr0555_to_rgb5551_mmx
			popa
		}
}


//////////////////////////////
// Convert BGR0555 to RGB5551
//////////////////////////////
void flip_palette(int palnum)
{
	if (isFlipped[palnum]) {
		currPalette = (unsigned char*)&palfx[palnum][0];
		return;
	}
	isFlipped[palnum] = true;

	currPalette = (unsigned char*)&palfx[palnum][0];
	if (useD3D)
		flip_colors_x555(currPalette, pal_base+((palnum&1)<<9), 512);
	else
		flip_colors(currPalette, pal_base+((palnum&1)<<9), 512);

}



void luma_inc(unsigned char *dest,unsigned char *src,int amount,bool skipfirst) {
	unsigned short first;
	if (skipfirst)
		first = *(unsigned short*)src;

	if (hasSSE2)
		__asm
		{
			pusha
			mov			esi,[src]
			movd		xmm0,[amount]
			mov			edi,[dest]
			punpcklwd	xmm0,xmm0
			movdqa		xmm1,[MASKBLUE]	// XMM1 - 001F 001F 001F ....
			punpckldq	xmm0,xmm0
			mov			ecx,32
			punpcklqdq	xmm0,xmm0		// XMM0 - evy evy evy ....
	__setup_luma_inc_sse2:
			movdqu		xmm2,[esi]		// Read 8 colors
			movdqa		xmm3,xmm2		// Copy
			movdqa		xmm5,xmm2		// Copy
			psrlw xmm3,[SHAMT4]
			pand		xmm3,xmm1		// XMM3 - Keep reds
			psrlw		xmm5,[SHAMT6]
			movdqa		xmm4,xmm1		// XMM4 = 31
			pand		xmm5,xmm1		// XMM5 = green 
			psubw		xmm4,xmm3		// XMM4 = 31-red
			movdqa		xmm6,xmm1		
			pmullw		xmm4,xmm0		// XMM4 = (31-red) * EVY
			psubw		xmm6,xmm5		// XMM6 = 31-green
			psrlw		xmm4,4			// XMM4 = (31-red) * EVY/16
			pmullw		xmm6,xmm0		
			paddw		xmm3,xmm4		// XMM3 = red + (31-red)*EVY/16
			psrlw		xmm2,[SHAMT5]	// XMM2 = blue
			psrlw		xmm6,4
			pand		xmm2,xmm1
			psllw		xmm3,[SHAMT1]
			paddw		xmm5,xmm6
			movdqa		xmm7,xmm1
			psllw		xmm5,[SHAMT3]
			psubw		xmm7,xmm2
			por			xmm3,xmm5
			pmullw		xmm7,xmm0
			add			esi,16
			psrlw		xmm7,4
			paddw		xmm2,xmm7
			psllw		xmm2,[SHAMT2]
			por			xmm3,xmm2
			movdqu		[edi],xmm3
			add			edi,16
			dec			ecx
			jnz			__setup_luma_inc_sse2
			popa
		}
	else
		__asm
		{
			pusha
			mov			esi,[src]
			movd		mm0,[amount]
			mov			edi,[dest]
			punpcklwd	mm0,mm0
			movq		mm1,[MASKBLUE]	// mm1 - 001F 001F 001F ....
			punpckldq	mm0,mm0
			mov			ecx,64
	__setup_luma_inc_mmx:
			movq		mm2,[esi]		// Read 4 colors
			movq		mm3,mm2			// Copy
			movq		mm5,mm2			// Copy
			psrlw mm3,[SHAMT4]
			pand		mm3,mm1			// mm3 - Keep reds
			psrlw		mm5,[SHAMT6]
			movq		mm4,mm1
			pand		mm5,mm1
			psubw		mm4,mm3
			movq		mm6,mm1
			pmullw		mm4,mm0
			psubw		mm6,mm5
			psrlw		mm4,4
			pmullw		mm6,mm0
			paddw		mm3,mm4
			psrlw		mm2,[SHAMT5]
			psrlw		mm6,4
			pand		mm2,mm1
			psllw		mm3,[SHAMT1]
			paddw		mm5,mm6
			movq		mm7,mm1
			psllw		mm5,[SHAMT3]
			psubw		mm7,mm2
			por			mm3,mm5
			pmullw		mm7,mm0
			add			esi,8
			psrlw		mm7,4
			paddw		mm2,mm7
			psllw		mm2,[SHAMT2] 
			por			mm3,mm2
			movq		[edi],mm3
			add			edi,8
			dec			ecx
			jnz			__setup_luma_inc_mmx
			popa
			emms
		}

	if (skipfirst) {
		*(unsigned short*)dest = (((first>>0)&31) <<(*(short*)&SHAMT1)) |
			                     (((first>>5)&31) <<(*(short*)&SHAMT3)) |
			                     (((first>>10)&31)<<(*(short*)&SHAMT2));
	}
}



void luma_dec(unsigned char *dest,unsigned char *src,int amount,bool skipfirst) {
	unsigned short first;
	if (skipfirst)
		first = *(unsigned short*)src;


	if (hasSSE2)
		__asm
		{
			pusha
			mov			esi,[src] 
			movd		xmm0,[amount]
			mov			edi,[dest]
			punpcklwd	xmm0,xmm0
			movdqa		xmm1,[MASKBLUE]
			punpckldq	xmm0,xmm0
			mov			ecx,32
			punpcklqdq	xmm0,xmm0
__setup_luma_dec_sse2:
			movdqu		xmm2,[esi]		// Read 8 colors
			movdqa		xmm3,xmm2		// Copy
			movdqa		xmm5,xmm2		// Copy
			psrlw		xmm3,[SHAMT4]
			pand		xmm3,xmm1		// XMM3 - Keep reds
			psrlw		xmm5,[SHAMT6]	// XMM5 - Shift right by 5
			movdqa		xmm4,xmm3		// XMM4 - Reds
			pand		xmm5,xmm1		// XMM5 - Keep greens
			pmullw		xmm3,xmm0		// XMM3 - Multiply by EVY
			movdqa		xmm6,xmm5		// XMM5 - Greens
			psrlw		xmm3,4			// XMM3 - Shift right by 4
			pmullw		xmm5,xmm0		// XMM5 - Multiply by EVY
			psrlw		xmm2,[SHAMT5]	// XMM2 - Shift right by 10
			psubw		xmm4,xmm3		// XMM4 - Subtract red*EVY/16 from red
			pand		xmm2,xmm1		// XMM2 - Keep blues
			psrlw		xmm5,4			// XMM5 - Shift right by 4
			psllw		xmm4,[SHAMT1]
			psubw		xmm6,xmm5		// XMM6 - Subtract green*EVY/16 from green
			movdqa		xmm3,xmm2		// XMM3 - Blues
			psllw		xmm6,[SHAMT3]
			pmullw		xmm2,xmm0
			por			xmm4,xmm6
			psrlw		xmm2,4
			psubw		xmm3,xmm2
			add			esi,16
			psllw		xmm3,[SHAMT2]
			por			xmm4,xmm3
			movdqu		[edi],xmm4
			add			edi,16
			dec			ecx
			jnz			__setup_luma_dec_sse2
			popa
		}
	else
		__asm
		{
			pusha
			mov			esi,[src] 
			movd		mm0,[amount]
			mov			edi,[dest]
			punpcklwd	mm0,mm0
			movq		mm1,[MASKBLUE]
			punpckldq	mm0,mm0
			mov			ecx,64
__setup_luma_dec_mmx:
			movq		mm2,[esi]		// Read 4 colors
			movq		mm3,mm2			// Copy
			movq		mm5,mm2			// Copy
			psrlw		mm3,[SHAMT4]
			pand		mm3,mm1			// mm3 - Keep reds
			psrlw		mm5,[SHAMT6]	// mm5 - Shift right by 5
			movq		mm4,mm3			// mm4 - Reds
			pand		mm5,mm1			// mm5 - Keep greens
			pmullw		mm3,mm0			// mm3 - Multiply by EVY
			movq		mm6,mm5			// mm5 - Greens
			psrlw		mm3,4			// mm3 - Shift right by 4
			pmullw		mm5,mm0			// mm5 - Multiply by EVY
			psrlw		mm2,[SHAMT5]	// mm2 - Shift right by 10
			psubw		mm4,mm3			// mm4 - Subtract red*EVY/16 from red
			pand		mm2,mm1			// mm2 - Keep blues
			psrlw		mm5,4			// mm5 - Shift right by 4
			psllw		mm4,[SHAMT1]
			psubw		mm6,mm5			// mm6 - Subtract green*EVY/16 from green
			movq		mm3,mm2			// mm3 - Blues
			psllw		mm6,[SHAMT3]
			pmullw		mm2,mm0
			por			mm4,mm6
			psrlw		mm2,4
			psubw		mm3,mm2
			add			esi,8
			psllw		mm3,[SHAMT2] 
			por			mm4,mm3
			movq		[edi],mm4
			add			edi,8
			dec			ecx
			jnz			__setup_luma_dec_mmx
			popa
			emms
		}

	if (skipfirst) {
		*(unsigned short*)dest = (((first>>0)&31) <<(*(short*)&SHAMT1)) |
			                     (((first>>5)&31) <<(*(short*)&SHAMT3)) |
			                     (((first>>10)&31)<<(*(short*)&SHAMT2));
	}

}



#define BLD1 EVB128
#define BLD2 EVA128

void alpha_blend() {
	// Paranoia never hurts..
	//if (!lineaddr)
	//	return;

	if (hasSSE2) {
	////////////////////////////////////////////////////////////////
	// SSE2 supported, use the SSE2 blender (~16 clocks/pixel)
	////////////////////////////////////////////////////////////////
	if (useGL && glOK && (glFormat==GL_UNSIGNED_SHORT_5_5_5_1))	{
		__asm
		{
			pusha

			mov			edi,[lineaddr]
			mov			esi,edi

			mov			eax,[numBlends]
			inc			eax
			add			eax,eax
			mul			dword ptr [vscreen_size]
			add			esi,eax

			mov			ebx,esi
			sub			ebx,[vscreen_size]
			sub			ebx,[vscreen_size]

			mov			edx,[p_alphamap]

			movd		xmm0,[eva]			// Copy eva into xmm0
			movd		xmm1,[evb]			// Copy evb into xmm1
			punpcklwd	xmm0,xmm0			// Unpack xmm0 - 0000 0000 00aa 00aa
			punpcklwd	xmm1,xmm1			// Unpack xmm1 - 0000 0000 00aa 00aa
			punpckldq	xmm0,xmm0			// Unpack xmm0 - 00aa 00aa 00aa 00aa
			punpckldq	xmm1,xmm1			// Unpack xmm1 - 00aa 00aa 00aa 00aa
			punpcklqdq	xmm0,xmm0			// Unpack xmm0 - 00aa 00aa 00aa 00aa 00aa 00aa 00aa 00aa
			punpcklqdq	xmm1,xmm1			// Unpack xmm1 - 00aa 00aa 00aa 00aa 00aa 00aa 00aa 00aa
			movdqa		[EVA128],xmm0		// Save the result into EVA128
			movdqa		xmm4,[MASKBLUE]
			movdqa		[EVB128],xmm1		// Save the result into EVB128

			mov		ecx,32
__ablend_sse2_loop:
			//rdtsc
			//mov dword ptr [fubar],eax

			movdqa		xmm6,[esi]			// Copy 16 bytes (8 pixels) from vscreen2 into xmm6
			movdqa		xmm7,[ebx] 			// Copy 16 bytes (8 pixels) from vscreen into xmm7

			movdqa		xmm0,xmm7			// BLU - Copy xmm7 to xmm0, destination pixels
			movdqa		xmm1,xmm6			// BLU - Copy xmm6 to xmm1, source pixels

			psrlw		xmm0,11				// BLU - shift each pixel to the right by 10 [000b 000b 000b 000b]
			psrlw		xmm1,11				// BLU - shift each pixel to the right by 10 [000b 000b 000b 000b]

			pand		xmm0,xmm4
			pand		xmm1,xmm4

			pmullw		xmm0,[BLD1]
			pmullw		xmm1,[BLD2] // A
			psrlw		xmm0,4
			psrlw		xmm1,4
			paddw		xmm0,xmm1
			movdqa		xmm3,xmm4
			movdqa		xmm5,xmm0
			pcmpgtw		xmm5,xmm3
			pand		xmm3,xmm5
			pandn		xmm5,xmm0
			por			xmm5,xmm3

			movdqa		xmm0,xmm7			// GRN - Copy xmm7 to xmm0, destination pixels
			movdqa		xmm1,xmm6			// GRN - Copy xmm6 to xmm1, source pixels

			psrlw		xmm0,6				// GRN - shift each pixel to the right by 5 [000g 000g 000g 000g]
			psrlw		xmm1,6				// GRN - shift each pixel to the right by 5 [000g 000g 000g 000g]

			pand		xmm0,xmm4
			pand		xmm1,xmm4

			pmullw		xmm0,[BLD1]
			pmullw		xmm1,[BLD2] //A
			psrlw		xmm0,4
			psrlw		xmm1,4
			paddw		xmm0,xmm1
			movdqa		xmm3,xmm4
			movdqa		xmm2,xmm0
			pcmpgtw		xmm2,xmm3
			pand		xmm3,xmm2
			pandn		xmm2,xmm0
			por			xmm2,xmm3
			psllw		xmm5,11
			psllw		xmm2,6
			por			xmm5,xmm2

			psrlw		xmm7,1
			psrlw		xmm6,1
			pand		xmm7,xmm4				// RED - and xmm7 with the red channel mask [0r00 0r00 0r00 0r00]
			pand		xmm6,xmm4				// RED - and xmm6 with red channel mask [0r00 0r00 0r00 0r00]

			pmullw		xmm7,[BLD1]
			pmullw		xmm6,[BLD2] // A
			movdqa		xmm3,xmm4
			psrlw		xmm7,4
			psrlw		xmm6,4
			paddw		xmm7,xmm6
			movdqa		xmm2,xmm7
			pcmpgtw		xmm2,xmm3
			pand		xmm3,xmm2
			pandn		xmm2,xmm7
			por			xmm2,xmm3
			psllw		xmm2,1
			por			xmm5,xmm2

			movq		mm1,[edx]
			movq2dq		xmm1,mm1
			movdqa		xmm2,[edi]
			punpcklbw	xmm1,xmm1
			pand		xmm5,xmm1
			pandn		xmm1,xmm2
			add			ebx,16
			por			xmm5,xmm1
			add			edx,8

			add			esi,16

			movdqa		[edi],xmm5			// Copy the 8 alpha blended pixels to the destination

			add			edi,16

			dec			ecx
			jnz			__ablend_sse2_loop
			emms
			popa
		}
	} else
	{
		__asm
		{
			pusha

			mov			edi,[lineaddr]
			mov			esi,edi
			mov			eax,[numBlends]
			inc			eax
			add			eax,eax
			mul			dword ptr [vscreen_size]
			add			esi,eax

			mov			ebx,esi
			sub			ebx,[vscreen_size]
			sub			ebx,[vscreen_size]

			mov			edx,[p_alphamap]

			movd		xmm0,[eva]			// Copy eva into xmm0
			movd		xmm1,[evb]			// Copy evb into xmm1
			punpcklwd	xmm0,xmm0			// Unpack xmm0 - 0000 0000 00aa 00aa
			punpcklwd	xmm1,xmm1			// Unpack xmm1 - 0000 0000 00aa 00aa
			punpckldq	xmm0,xmm0			// Unpack xmm0 - 00aa 00aa 00aa 00aa
			punpckldq	xmm1,xmm1			// Unpack xmm1 - 00aa 00aa 00aa 00aa
			punpcklqdq	xmm0,xmm0			// Unpack xmm0 - 00aa 00aa 00aa 00aa 00aa 00aa 00aa 00aa
			punpcklqdq	xmm1,xmm1			// Unpack xmm1 - 00aa 00aa 00aa 00aa 00aa 00aa 00aa 00aa
			movdqa		[EVA128],xmm0		// Save the result into EVA128
			movdqa		xmm4,[MASKBLUE]
			movdqa		[EVB128],xmm1		// Save the result into EVB128

			mov			ecx,32
__ablend_sse2_loop_2:
			//rdtsc
			//mov		dword ptr [fubar],eax

			movdqa		xmm6,[esi]			// Copy 16 bytes (8 pixels) from vscreen2 into xmm6
			movdqa		xmm7,[ebx]			// Copy 16 bytes (8 pixels) from vscreen into xmm7

			movdqa		xmm0,xmm7			// BLU - Copy xmm7 to xmm0, destination pixels
			movdqa		xmm1,xmm6			// BLU - Copy xmm6 to xmm1, source pixels

			psrlw		xmm0,10				// BLU - shift each pixel to the right by 10 [000b 000b 000b 000b]
			psrlw		xmm1,10				// BLU - shift each pixel to the right by 10 [000b 000b 000b 000b]

			pand		xmm0,xmm4
			pand		xmm1,xmm4

			pmullw		xmm0,[BLD1]
			pmullw		xmm1,[BLD2]
			psrlw		xmm0,4
			psrlw		xmm1,4
			paddw		xmm0,xmm1
			movdqa		xmm3,xmm4
			movdqa		xmm5,xmm0
			pcmpgtw		xmm5,xmm3
			pand		xmm3,xmm5
			pandn		xmm5,xmm0
			por			xmm5,xmm3

			movdqa		xmm0,xmm7			// GRN - Copy xmm7 to xmm0, destination pixels
			movdqa		xmm1,xmm6			// GRN - Copy xmm6 to xmm1, source pixels

			psrlw		xmm0,5				// GRN - shift each pixel to the right by 5 [000g 000g 000g 000g]
			psrlw		xmm1,5				// GRN - shift each pixel to the right by 5 [000g 000g 000g 000g]

			pand		xmm0,xmm4
			pand		xmm1,xmm4

			pmullw		xmm0,[BLD1]
			pmullw		xmm1,[BLD2] //A
			psrlw		xmm0,4
			psrlw		xmm1,4
			paddw		xmm0,xmm1
			movdqa		xmm3,xmm4
			movdqa		xmm2,xmm0
			pcmpgtw		xmm2,xmm3
			pand		xmm3,xmm2
			pandn		xmm2,xmm0
			por			xmm2,xmm3
			psllw		xmm5,10
			psllw		xmm2,5
			por			xmm5,xmm2

			pand		xmm7,xmm4				// RED - and xmm7 with the red channel mask [0r00 0r00 0r00 0r00]
			pand		xmm6,xmm4				// RED - and xmm6 with red channel mask [0r00 0r00 0r00 0r00]

			pmullw		xmm7,[BLD1]
			pmullw		xmm6,[BLD2] // A
			movdqa		xmm3,xmm4
			psrlw		xmm7,4
			psrlw		xmm6,4
			paddw		xmm7,xmm6
			movdqa		xmm2,xmm7
			pcmpgtw		xmm2,xmm3
			pand		xmm3,xmm2
			pandn		xmm2,xmm7
			por			xmm2,xmm3
			por			xmm5,xmm2
__sse2_next_pixels:
			add			esi,16

			movq		mm1,[edx]
			movq2dq		xmm1,mm1
			movdqa		xmm2,[edi]
			punpcklbw	xmm1,xmm1
			pand		xmm5,xmm1
			pandn		xmm1,xmm2
			add			ebx,16
			por			xmm5,xmm1
			add			edx,8

			movdqa		[edi],xmm5			// Copy the 8 alpha blended pixels to the destination

			add			edi,16

			//rdtsc
			//sub		eax,dword ptr [fubar]
			//mov		dword ptr [fubar],eax

			dec			ecx
			jnz			__ablend_sse2_loop_2
			popa
		}
	}
	} else {
	////////////////////////////////////////////////////////////////
	// SSE2 not supported, resort to MMX blender (~32 clocks/pixel)
	////////////////////////////////////////////////////////////////
	if (useGL && glOK && (glFormat==GL_UNSIGNED_SHORT_5_5_5_1))	{
		__asm
		{
			pusha

			mov			edi,[lineaddr]

			movd		mm0,[eva]			// Copy eva into mm0
			movd		mm1,[evb]			// Copy evb into mm1

			add			edi,512

			punpcklwd	mm0,mm0				// Unpack mm0 - 0000 0000 00aa 00aa
			punpcklwd	mm1,mm1				// Unpack mm1 - 0000 0000 00aa 00aa

			mov			esi,edi

			punpckldq	mm0,mm0				// Unpack mm0 - 00aa 00aa 00aa 00aa
			punpckldq	mm1,mm1				// Unpack mm1 - 00aa 00aa 00aa 00aa

			mov			eax,[numBlends]
			inc			eax
			add			eax,eax
			mul			dword ptr [vscreen_size]
			add			esi,eax

			mov			ebx,esi
			sub			ebx,[vscreen_size]
			sub			ebx,[vscreen_size]

			mov			edx,[p_alphamap]

			movq		[EVA128],mm0		// Save the result into EVA128
			movq		mm4,[MASKBLUE]		// Channel mask (001F 001F 001F 001F)
			movq		[EVB128],mm1		// Save the result into EVB128

			mov			ecx,-64				// Use negative indexing to save 2 instructions in the inner loop
__ablend_mmx_loop:
			movq		mm6,[esi+ecx*8]		// Copy 8 bytes (4 pixels) from vscreen2 into xmm6
			movq		mm7,[ebx+ecx*8]		// Copy 8 bytes (4 pixels) from vscreen into xmm7

			movq		mm0,mm7				// BLU - Copy mm7 to mm0, destination pixels
			movq		mm1,mm6				// BLU - Copy mm6 to mm1, source pixels

			psrlw		mm0,11				// BLU - Shift each pixel to the right by 10 [000b 000b 000b 000b]
			psrlw		mm1,11				// BLU - Shift each pixel to the right by 10 [000b 000b 000b 000b]

			pand		mm0,mm4
			pand		mm1,mm4

			pmullw		mm0,[EVB128]		// BLU - Multiply dest component with EVB
			pmullw		mm1,[EVA128]		// BLU - Multiply source component with EVA
			psrlw		mm0,4				// BLU - Shift right by 4 (divide by 16)
			psrlw		mm1,4
			paddw		mm0,mm1				// BLU - Add source and dest components
			movq		mm3,mm4
			movq		mm5,mm0
			pcmpgtw		mm5,mm3				// BLU - Make sure result doesn't exceed 0x1F
			pand		mm3,mm5
			pandn		mm5,mm0				// BLU - Keep those components that doesn't exceed 0x1F
			por			mm5,mm3				// BLU - OR in the other components which have been set to 0x1F

			movq		mm0,mm7				// GRN - Copy mm7 to mm0, destination pixels
			movq		mm1,mm6				// GRN - Copy mm6 to mm1, source pixels

			psrlw		mm0,6				// GRN - Shift each pixel to the right by 5 [000g 000g 000g 000g]
			psrlw		mm1,6				// GRN - Shift each pixel to the right by 5 [000g 000g 000g 000g]

			pand		mm0,mm4
			pand		mm1,mm4

			pmullw		mm0,[EVB128]			// GRN
			pmullw		mm1,[EVA128]			// GRN
			psrlw		mm0,4
			psrlw		mm1,4
			paddw		mm0,mm1
			movq		mm3,mm4
			movq		mm2,mm0
			pcmpgtw		mm2,mm3
			pand		mm3,mm2
			pandn		mm2,mm0
			por			mm2,mm3
			psllw		mm5,11				// BLU - Shift components left by 10
			psllw		mm2,6					// GRN - Shift components left by 5
			por			mm5,mm2					// BLU - OR in the green bits

			psrlw		mm7,1
			psrlw		mm6,1
			pand		mm7,mm4				// RED - and mm7 with the channel mask [000r 000r 000r 000r]
			pand		mm6,mm4				// RED - and mm6 with the channel mask [000r 000r 000r 000r]

			pmullw		mm7,[EVB128]			// RED
			pmullw		mm6,[EVA128]			// RED
			movq		mm3,mm4
			psrlw		mm7,4
			psrlw		mm6,4
			paddw		mm7,mm6
			movq		mm2,mm7
			pcmpgtw		mm2,mm3
			pand		mm3,mm2
			pandn		mm2,mm7
			por			mm2,mm3
			psllw		mm2,1
			por			mm5,mm2

			movd		mm1,[edx]
			movq		mm2,[edi+ecx*8]
			punpcklbw	mm1,mm1
			pand		mm5,mm1
			pandn		mm1,mm2
			por			mm5,mm1
			add			edx,4

			movq		[edi+ecx*8],mm5		// Copy the 4 alpha blended pixels to the destination

			inc			ecx
			jnz			__ablend_mmx_loop
			popa
			emms
		}
		} else {
		__asm
		{
			pusha

			mov			edi,[lineaddr]

			movd		mm0,[eva]				// Copy eva into mm0
			movd		mm1,[evb]				// Copy evb into mm1

			add			edi,512

			punpcklwd	mm0,mm0				// Unpack mm0 - 0000 0000 00aa 00aa
			punpcklwd	mm1,mm1				// Unpack mm1 - 0000 0000 00aa 00aa

			mov			esi,edi

			punpckldq	mm0,mm0				// Unpack mm0 - 00aa 00aa 00aa 00aa
			punpckldq	mm1,mm1				// Unpack mm1 - 00aa 00aa 00aa 00aa

			//sub		esi,[vscreen_curr]
			//add		esi,[vscreen_size]
			//add		esi,[vscreen_size]
			mov			eax,[numBlends]
			inc			eax
			add			eax,eax
			mul			dword ptr [vscreen_size]
			add			esi,eax

			mov			ebx,esi
			sub			ebx,[vscreen_size]
			sub			ebx,[vscreen_size]

			mov			edx,[p_alphamap]

			movq		[EVA128],mm0		// Save the result into EVA128
			movq		mm4,[MASKBLUE]		// Channel mask (001F 001F 001F 001F)
			movq		[EVB128],mm1		// Save the result into EVB128

			//add		esi,[vscreen2]		// Point to esi to the same line but in vscreen2

			mov			ecx,-64				// Use negative indexing to save 2 instructions in the inner loop

__ablend_mmx_loop2:
			movq		mm6,[esi+ecx*8]		// Copy 8 bytes (4 pixels) from vscreen2 into xmm6
			movq		mm7,[ebx+ecx*8]		// Copy 8 bytes (4 pixels) from vscreen into xmm7

			movq		mm0,mm7				// BLU - Copy mm7 to mm0, destination pixels
			movq		mm1,mm6				// BLU - Copy mm6 to mm1, source pixels

			psrlw		mm0,10				// BLU - Shift each pixel to the right by 10 [000b 000b 000b 000b]
			psrlw		mm1,10				// BLU - Shift each pixel to the right by 10 [000b 000b 000b 000b]

			pand		mm0,mm4
			pand		mm1,mm4

			pmullw		mm0,[EVB128]		// BLU - Multiply dest component with EVB
			pmullw		mm1,[EVA128]		// BLU - Multiply source component with EVA
			psrlw		mm0,4				// BLU - Shift right by 4 (divide by 16)
			psrlw		mm1,4
			paddw		mm0,mm1				// BLU - Add source and dest components
			movq		mm3,mm4
			movq		mm5,mm0
			pcmpgtw		mm5,mm3				// BLU - Make sure result doesn't exceed 0x1F
			pand		mm3,mm5
			pandn		mm5,mm0				// BLU - Keep those components that doesn't exceed 0x1F
			por			mm5,mm3				// BLU - OR in the other components which have been set to 0x1F

			movq		mm0,mm7				// GRN - Copy mm7 to mm0, destination pixels
			movq		mm1,mm6				// GRN - Copy mm6 to mm1, source pixels

			psrlw		mm0,5				// GRN - Shift each pixel to the right by 5 [000g 000g 000g 000g]
			psrlw		mm1,5				// GRN - Shift each pixel to the right by 5 [000g 000g 000g 000g]

			pand		mm0,mm4
			pand		mm1,mm4

			pmullw		mm0,[EVB128]		// GRN
			pmullw		mm1,[EVA128]		// GRN
			psrlw		mm0,4
			psrlw		mm1,4
			paddw		mm0,mm1
			movq		mm3,mm4
			movq		mm2,mm0
			pcmpgtw		mm2,mm3
			pand		mm3,mm2
			pandn		mm2,mm0
			por			mm2,mm3
			psllw		mm5,10				// BLU - Shift components left by 10
			psllw		mm2,5				// GRN - Shift components left by 5
			por			mm5,mm2				// BLU - OR in the green bits

			pand		mm7,mm4				// RED - and mm7 with the channel mask [000r 000r 000r 000r]
			pand		mm6,mm4				// RED - and mm6 with the channel mask [000r 000r 000r 000r]

			pmullw		mm7,[EVB128]		// RED
			pmullw		mm6,[EVA128]		// RED
			movq		mm3,mm4
			psrlw		mm7,4
			psrlw		mm6,4
			paddw		mm7,mm6
			movq		mm2,mm7
			pcmpgtw		mm2,mm3
			pand		mm3,mm2
			pandn		mm2,mm7
			por			mm2,mm3
			por			mm5,mm2

			movd		mm1,[edx]
			movq		mm2,[edi+ecx*8]
			punpcklbw	mm1,mm1
			pand		mm5,mm1
			pandn		mm1,mm2
			por			mm5,mm1
			add			edx,4

			movq		[edi+ecx*8],mm5		// Copy the 4 alpha blended pixels to the destination

			inc			ecx
			jnz			__ablend_mmx_loop2
			popa
			emms
		}
		}
		}
		numBlends++;
}
