#include "tabs.h"


void CALLBACK propsheet_callback(HWND hwndPropSheet, UINT uMsg, LPARAM lParam)
{
	switch(uMsg)
	{
		// Called before the dialog is created, hwndPropSheet = NULL, lParam points to dialog resource
		case PSCB_PRECREATE:
		{
			LPDLGTEMPLATE lpTemplate = (LPDLGTEMPLATE)lParam;
			lpTemplate->style &= ~WS_VISIBLE;
		}
		break;

		// Called after the dialog is created
		case PSCB_INITIALIZED:
		break;

	}
}


LRESULT CALLBACK page1_dlgproc(HWND hdlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LPNMHDR lpnmhdr;
	HWND hwnd,hCtl;
	static int irqEnabled=1;
	static int irqEnabledSub=1;
	static int turboSWISub=1;

	switch (uMsg)
	{
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
			case IDC_CHECK1:
				hCtl = GetDlgItem(hdlg,IDC_CHECK1);
				irqEnabled = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
				cpu_set(CPU_ENABLE_IRQ,irqEnabled,irqEnabled);
				break;
			case IDC_CHECK2:
				hCtl = GetDlgItem(hdlg,IDC_CHECK2);
				irqEnabledSub = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
				cpu_sub_set(CPU_ENABLE_IRQ,irqEnabledSub,irqEnabledSub);
				break;
			case IDC_CHECK3:
				hCtl = GetDlgItem(hdlg,IDC_CHECK3);
				turboSWISub = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
				cpu_set(PLUGIN_SETTING,0x333,turboSWISub);
				cpu_sub_set(PLUGIN_SETTING,0x333,turboSWISub);
				break;
		}
		SetFocus(hMain);
		break;

	case WM_NOTIFY:
		lpnmhdr = (NMHDR*)lParam;

		switch (lpnmhdr->code)
		{
		case PSN_APPLY:   // Sent when OK or Apply button pressed
            break;

		case PSN_RESET:   // Sent when Cancel button pressed
            break;

		case PSN_SETACTIVE:
			hwnd = GetDlgItem(hdlg,IDC_CHECK1);
			SendMessage(hwnd,BM_SETCHECK,irqEnabled,0);
			hwnd = GetDlgItem(hdlg,IDC_CHECK2);
			SendMessage(hwnd,BM_SETCHECK,irqEnabled,0);
			hwnd = GetDlgItem(hdlg,IDC_CHECK3);
			SendMessage(hwnd,BM_SETCHECK,turboSWISub,0);
            break;

		default:
            break;
		}
		break;

		default:
			break;
	}

	return FALSE;
}


LRESULT CALLBACK page2_dlgproc(HWND hdlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LPNMHDR lpnmhdr;
	HWND hCtl;
	int i;
	static bool firstTime=true;
	//static int cfDevice = 1;

	switch (uMsg)
	{
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
			case IDC_IPC_1:
			case IDC_IPC_2:
				hCtl = GetDlgItem(hdlg,IDC_IPC_1);
				ipcLoc = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 0 : 1;
				mmu_set(PLUGIN_SETTING,10,ipcLoc);
				break;
			case IDC_CHECK1:
				hCtl = GetDlgItem(hdlg,IDC_CHECK1);
				mirrorIPC = (SendMessage(hCtl, BM_GETCHECK, 0, 0)==BST_CHECKED) ? 1 : 0;
				mmu_set(PLUGIN_SETTING, 11, mirrorIPC);
				break;

			case IDC_COMBO1:
			case IDC_COMBO2:
				return 0;
			case IDC_COMBO3:
				if (HIWORD(wParam)==CBN_SELCHANGE)
				{
					hCtl = GetDlgItem(hdlg,LOWORD(wParam));
					theme = (unsigned char)SendMessage(hCtl,CB_GETCURSEL,0,0);
					//if (romLoaded)
						mmu_write_byte(0x23FFC82,theme);
				}
				return 0;
				break;

			case IDC_COMBO4:
				if (HIWORD(wParam)==CBN_SELCHANGE)
				{
					hCtl = GetDlgItem(hdlg,LOWORD(wParam));
					ipcFormat = SendMessage(hCtl,CB_GETCURSEL,0,0)+1;
					//if (romLoaded)
						mmu_set(PLUGIN_SETTING,20,ipcFormat);
				}
				return 0;
				break;

			case IDC_COMBO5:
				if (HIWORD(wParam)==CBN_SELCHANGE) {
					hCtl = GetDlgItem(hdlg,LOWORD(wParam));
					i = cfDevice;
					cfDevice = SendMessage(hCtl,CB_GETCURSEL,0,0);
					mmu_set(PLUGIN_SETTING,70,cfDevice);
					if (romLoaded&&(cfDevice!=i))
						if (MessageBox(NULL,"This operation requires an emulation reset to take affect. Do you wish to reset emulation now?","Dualis",MB_YESNO)==IDYES)
							reset_machine(false);
				}
				return 0;

		}
		SetFocus(hMain);
		break;

	case WM_INITDIALOG:
		//SetWindowLong(hdlg, DWL_USER, lParam);
		if (firstTime)
		{
			hCtl = GetDlgItem(hdlg,IDC_EDIT1);
			SetWindowText(hCtl,"G.W. Bush");

			hCtl = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"January");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"February");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"March");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"April");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"May");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"June");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"July");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"August");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"September");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"October");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"November");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"December");
			SendMessage(hCtl,CB_SETCURSEL,6,0);

			hCtl = GetDlgItem(hdlg,IDC_COMBO3);
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Gray");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Maroon");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Red");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Pink");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Orange");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Yellow");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Lime");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Green");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Dark Green");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Teal");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Light Blue");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Blue");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Dark Blue");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Dark Purple");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Light Purple");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"Dark Pink");
			SendMessage(hCtl,CB_SETCURSEL,(theme>15)?15:theme,0);

			hCtl = GetDlgItem(hdlg,IDC_COMBO4);
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"v1");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"v2");
			SendMessage(hCtl,CB_SETCURSEL,ipcFormat-1,0);

			hCtl = GetDlgItem(hdlg,IDC_COMBO5);
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"None");
			SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"GBAMP");
			//SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"M3");
			SendMessage(hCtl,CB_SETCURSEL,cfDevice,0);

			hCtl = GetDlgItem(hdlg,IDC_COMBO2);
			for (i=1; i<32; i++)
			{
				wsprintf(szBuffer,"%d",i);
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)szBuffer);
			}
			SendMessage(hCtl,CB_SETCURSEL,5,0);
			firstTime = false;
		}
		break;

	case WM_NOTIFY:
		lpnmhdr = (NMHDR*)lParam;

		switch (lpnmhdr->code)
		{
		case PSN_APPLY:   //sent when OK or Apply button pressed
            break;

		case PSN_RESET:   //sent when Cancel button pressed
            break;

		case PSN_SETACTIVE:
			//SetWindowLong(hdlg, DWL_USER, lParam);
			hCtl = GetDlgItem(hdlg,IDC_IPC_1);
			SendMessage(hCtl,BM_SETCHECK,1-ipcLoc,0);
			hCtl = GetDlgItem(hdlg,IDC_IPC_2);
			SendMessage(hCtl,BM_SETCHECK,ipcLoc,0);
			hCtl = GetDlgItem(hdlg,IDC_CHECK1);
			SendMessage(hCtl,BM_SETCHECK,mirrorIPC,0);
			break;

		default:
            break;
		}
		break;

		default:
			break;
	}

	return FALSE;
}


LRESULT CALLBACK page3_dlgproc(HWND hdlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LPNMHDR lpnmhdr;
	HWND hCtl;
	int i;
	static bool firstTime=true;
	static int texFrmt = 1;

	switch (uMsg)
	{
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
			case IDC_CHECK_FPS:
				//MessageBox(NULL,"WM_COMMAND","DIALOG2",MB_OK);
				hCtl = GetDlgItem(hdlg,IDC_CHECK_FPS);
				fpsLimit = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
				gpu_set(PLUGIN_SETTING,1,fpsLimit);
				break;

			case IDC_CHECK_NO3D:
				hCtl = GetDlgItem(hdlg,IDC_CHECK_NO3D);
				emulate3D = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED)?false:true;
				gpu_set(PLUGIN_SETTING,26,((emulate3D)?1:0));
				break;

			case IDC_RADIO_TEX1:
				hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX1);
				texFrmt = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 0 : 1;
				gpu_set(PLUGIN_SETTING,5,0x8366-(texFrmt*0x332));
				break;
			case IDC_RADIO_TEX2:
				hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX2);
				texFrmt = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
				gpu_set(PLUGIN_SETTING,5,0x8366-(texFrmt*0x332));
				break;

			case IDC_RADIO_OGL:
				hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX1);
				EnableWindow(hCtl, TRUE);
				hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX2);
				EnableWindow(hCtl, TRUE);
				renderer = 0;
				gpu_set(PLUGIN_SETTING,20,renderer);
				break;
			case IDC_RADIO_D3D:
			case IDC_RADIO_GDI:
				hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX1);
				EnableWindow(hCtl, FALSE);
				hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX2);
				EnableWindow(hCtl, FALSE);
				hCtl = GetDlgItem(hdlg,IDC_RADIO_OGL);
				renderer = ((SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 0 : -1);
				if (renderer == -1)
				{
					hCtl = GetDlgItem(hdlg,IDC_RADIO_D3D);
					renderer = ((SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 2);
				}
				gpu_set(PLUGIN_SETTING,20,renderer);
				break;

			case IDC_BG0_EN:
			case IDC_BG1_EN:
			case IDC_BG2_EN:
			case IDC_BG3_EN:
			case IDC_OBJ_EN:
				hCtl = GetDlgItem(hdlg,LOWORD(wParam));
				gpu_set(PLUGIN_SETTING,8,(LOWORD(wParam)-IDC_BG0_EN)|((SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 0x10000 : 0));
				break;

			case IDC_BG0_EN2:
			case IDC_BG1_EN2:
			case IDC_BG2_EN2:
			case IDC_BG3_EN2:
			case IDC_OBJ_EN2:
				hCtl = GetDlgItem(hdlg,LOWORD(wParam));
				gpu_set(PLUGIN_SETTING,8,(LOWORD(wParam)-IDC_BG0_EN2)|0x100|((SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 0x10000 : 0));
				break;

			case IDC_COMBO_SKIP:
				if (HIWORD(wParam)==CBN_SELCHANGE)
				{
					hCtl = GetDlgItem(hdlg,LOWORD(wParam));
					frameskip = SendMessage(hCtl,CB_GETCURSEL,0,0);
					gpu_set(PLUGIN_SETTING,0,frameskip);
				}
				return 0;

		}
		SetFocus(hMain);
		break;

	case WM_NOTIFY:
		lpnmhdr = (NMHDR*)lParam;

		switch (lpnmhdr->code)
		{
		case PSN_APPLY:   //sent when OK or Apply button pressed
            break;

		case PSN_RESET:   //sent when Cancel button pressed
            break;

		case PSN_SETACTIVE:
			if (firstTime)
			{
				hCtl = GetDlgItem(hdlg,IDC_COMBO_SKIP);
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"0");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"1");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"2");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"3");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"4");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"5");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"6");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"7");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"8");
				SendMessage(hCtl,CB_ADDSTRING,0,(LPARAM)"9");
				SendMessage(hCtl,CB_SETCURSEL,frameskip,0);
				//EnableWindow(hCtl,TRUE);
			}

			hCtl = GetDlgItem(hdlg,IDC_RADIO_OGL+renderer);
			SendMessage(hCtl,BM_SETCHECK,1,0);
			if (gpu_get != NULL)
				if ((gpu_get(GPU_RENDERER_OK)&2)==0)
				{
					hCtl = GetDlgItem(hdlg,IDC_RADIO_D3D);
					EnableWindow(hCtl,FALSE);
				}

			hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX1);
			SendMessage(hCtl,BM_SETCHECK,1-texFrmt,0);
			hCtl = GetDlgItem(hdlg,IDC_RADIO_TEX2);
			SendMessage(hCtl,BM_SETCHECK,texFrmt,0);

			hCtl = GetDlgItem(hdlg,IDC_CHECK_FPS);
			SendMessage(hCtl,BM_SETCHECK,fpsLimit,0);
			hCtl = GetDlgItem(hdlg,IDC_3D_BUFFER);
			SendMessage(hCtl,BM_SETCHECK,1,0);

			for (i=IDC_BG0_EN; i<=IDC_OBJ_EN; i++)
			{
				hCtl = GetDlgItem(hdlg,i);
				SendMessage(hCtl,BM_SETCHECK,1,0);
				hCtl = GetDlgItem(hdlg,i+11);
				SendMessage(hCtl,BM_SETCHECK,1,0);
			}

			firstTime = false;

			break;

		default:
            break;
		}
		break;

		default:
			break;
	}

	return FALSE;
}


/* Audio tab */
LRESULT CALLBACK page4_dlgproc(HWND hdlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LPNMHDR lpnmhdr;
	HWND hCtl;

	switch (uMsg)
	{
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
			case IDC_CHECK1:
				hCtl = GetDlgItem(hdlg,IDC_CHECK1);
				soundMasterEnable = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
				//if (!soundMasterEnable)
				apu_set(APU_PAUSE,1-soundMasterEnable,0);
				break;
			default:
				break;
		}
		SetFocus(hMain);
		break;

	case WM_NOTIFY:
		lpnmhdr = (NMHDR*)lParam;

		switch (lpnmhdr->code)
		{
		case PSN_APPLY:   //sent when OK or Apply button pressed
            break;

		case PSN_RESET:   //sent when Cancel button pressed
            break;

		case PSN_SETACTIVE:
			hCtl = GetDlgItem(hdlg,IDC_CHECK1);
			SendMessage(hCtl,BM_SETCHECK,soundMasterEnable&1,0);

			break;

		default:
            break;
		}
		break;

		default:
			break;
	}

	return FALSE;
}


HWND create_propsheet()
{
	PROPSHEETPAGE psp[4];
	PROPSHEETHEADER psh;
	int i;

	memset(psp, 0, sizeof(PROPSHEETPAGE) * 2);
	memset(&psh, 0, sizeof(PROPSHEETHEADER));

	for (i=0; i<4; i++)
	{
		psp[i].dwSize		 = sizeof(PROPSHEETPAGE);
		psp[i].dwFlags		 = PSP_USETITLE;
		psp[i].hInstance	 = hInst;
		psp[i].pszTemplate	 = MAKEINTRESOURCE(IDD_DIALOG1+i);
		psp[i].pszIcon		 = NULL;
		psp[i].pfnDlgProc	 = (DLGPROC)PageDlgProc[i];
		psp[i].pszTitle 	 = TEXT(szPropsheetCaption[i]);
		//	psp[0].lParam		 = 0;
	}

	//Fill out the PROPSHEETHEADER
	psh.dwSize			 = sizeof(PROPSHEETHEADER);
	psh.dwFlags 		 = PSH_PROPSHEETPAGE | PSH_USECALLBACK| PSH_MODELESS;
	psh.hwndParent		 = hMain;
	psh.hInstance        = NULL;
	psh.pszIcon 		 = NULL;
	psh.pszCaption		 = NULL;
	psh.nPages			 = sizeof(psp) / sizeof(PROPSHEETPAGE);
	psh.nStartPage		 = 2;
	psh.ppsp			 = (LPCPROPSHEETPAGE) &psp;
	psh.pfnCallback 	 = (PFNPROPSHEETCALLBACK)propsheet_callback;

	return (HWND)PropertySheet(&psh);
}


void center_propsheet(DWORD dwSize)
{
	RECT rect;

	GetWindowRect(hPropsheet, &rect);

	int xL = LOWORD(dwSize) / 2 - (rect.right - rect.left) / 2;
	int yT = HIWORD(dwSize) / 2 - (rect.bottom - rect.top) / 2;

	/*SetWindowPos(hPropsheet, NULL, 0, 20, LOWORD(dwSize), HIWORD(dwSize),
				 SWP_NOZORDER | SWP_NOACTIVATE);*/
	MoveWindow(hPropsheet,0,20,LOWORD(dwSize),HIWORD(dwSize),TRUE);
}


void init_propsheet_size()
{
	RECT rectWnd;
	RECT rectButton;

	GetWindowRect(hPropsheet,&rectWnd);
	HWND hWnd = GetDlgItem(hPropsheet, IDOK);

	if(!hWnd)
	{
		//DebugBreak();
		return;
	}

	GetWindowRect(hWnd, &rectButton);
	ShowWindow(hPropsheet,SW_SHOW);

	/*SetWindowPos(hPropsheet, NULL, 0, 20,
		rectWnd.right - rectWnd.left, rectButton.top - rectWnd.top,
	 SWP_NOZORDER | SWP_NOACTIVATE | SWP_SHOWWINDOW);*/

	for (int i=0; i<4; i++)
	{
		hWnd = GetDlgItem(hPropsheet, propSheetButtons[i]);
		if (hWnd != NULL)
		{
			ShowWindow(hWnd, SW_HIDE);
			EnableWindow(hWnd, FALSE);
		}
	}
}

